QGIS Application - Bug report #12713
when columns have the same name, styling with the first one does not work
2015-05-07 10:05 AM - Paolo Cavallini

Status: Open

Priority: Normal

Assignee:

Category: Vectors

Affected QGIS version:3.0.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 20819
Description

new description:

#12713-3

old description:

This file:
http://www.faunalia.eu/~paolo/qgis/result.zip

resulting from

processing.runalg("saga:gridstatisticsforpolygons","/tmp/RESULT .tif","/path/municipalities.shp",False,False, True,False, True,False,False
False,0,None)

seems impossible to thematize on the basis of the “Calculated™ column.

If saved as a new shapefile, it is OK. Possibly SAGA produces a wrong dbf?

History

#1 - 2015-05-09 01:37 PM - Even Rouault

Examination with ogrinfo shows that there are in fact 2 columns with same name "Calculated" (and with different values), which must confuse QGIS.

#2 - 2015-05-10 07:37 AM - Paolo Cavallini

- Target version set to Future Release - High Priority

- Category changed from Symbology to Processing/SAGA

Merci Even for checking. So this should be either an issue of Processing, not giving appropriate column names, or upstream (saga).

#3 - 2015-05-12 01:17 AM - Giovanni Manghi

- Affected QGIS version changed from 2.8.1 to master
- Status changed from Open to Feedback

- Category changed from Processing/SAGA to Vectors

- Subject changed from Shp cannot be stylized to shapefile cannot be stylized when columns have the same name

There are two issues here, but the real one seems a qgis issue.

The SAGA module gridstatisticsforpolygons creates an output shapefile where the statistics are placed into columns that are called "nameoftheinputraster
http://www.faunalia.eu/~paolo/qgis/result.zip

[nameofthestatistics]" and this is very likely to hit the 10 char limit for column names. So the result is likely to have different columns that have the exactly

same name (the first 10 chars of input raster), and this is confirmed by ogrinfo of course.

When opening a shapefile with at least two columns with the exact same name, ex: "columnname”, qgis "changes" the name of the 2nd, 3rd... to

"columnname_1", "columnname_2", etc. Styling using the values for this "renamed" columns works, but not for the first one.

#4 - 2015-05-22 05:49 AM - Giovanni Manghi
- Status changed from Feedback to Open

#5 - 2015-05-29 11:10 PM - Giovanni Manghi

- Subject changed from shapefile cannot be stylized when columns have the same name to when columns have the same name, styling with the first one
does not work

#6 - 2017-05-01 01:07 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#7 - 2017-08-08 12:46 AM - Jiirgen Fischer
- Description updated

#8 - 2018-03-07 04:38 PM - Paolo Cavallini

- Affected QGIS version changed from master to 3.0.0

Still true in QGIS 3.
